static void Fixed_Point_New_Depth_First_Label(int i, double weight)
{ 
  int nexti,a;
  a=piinv_idx[i];
  while (a != -1 && visited[piinv_elem[a]]==0)
    {
      nexti=piinv_elem[a];
      visited[nexti]=1;
      v[nexti]= weight+ c[nexti]+ v[i];
      component[nexti]=color;
      New_Depth_First_Label(nexti);
      a=piinv_succ[a];
    }
}
static void Fixed_Point_Visit_From(int initialpoint,int color)
{ int index,newindex,i;
  double weight;
  int length;
  if (verbose>1)
   printf("visiting from node %d color=%d\n",initialpoint, color);
  index=initialpoint;
  component[index]=color;
  newindex=pi[index];
  while (component[newindex]==0)
    {
      component[newindex]=color;
      index=newindex;
      newindex=pi[index];
    }
  /* a cycle has been detected, since newindex is already visited */ 
  weight=0;
  length=0;
  i=index;
  do
    {
      weight+=c[i];
      length++;
      i=pi[i];
    }
  while (i !=index);
  if (weight>epsilon)
    {   positivecycle=1;
        printf("POSITIVE CIRCUIT FOUND IN NODE %d\n",newindex);
    }
  if (newindex!=(nnodes-1))
    {
    ERRORMESS3("NEWINDEX =%d!=nnodes = %d\n",newindex,nnodes);
    v[i]=EPSILON;
    Fixed_Point_New_Depth_First_Label(index,EPSILON);
    }
  else
    {
    ERRORMESS("CIRCUIT FOUND AT FINAL NODE, OK");
    v[i]=0; 
    Fixed_Point_New_Depth_First_Label(index,0);
    }
}

/*       Fixed_Point_Value() */
/* Computes the value v associated with a policy pi for the fixed point pb x=Ax+b */

static void Fixed_Point_Value()
{ int initialpoint;
  color=1;
  positivecycle=0;
  ERRORMESS("Computing the value\n");
  Init_Depth_First();
  initialpoint=0;
  do
    { 
      Fixed_Point_Visit_From(initialpoint,color);
      while ((initialpoint<nnodes) && (component[initialpoint] !=0))
	  initialpoint++;
      color++;
    }
  while (initialpoint<nnodes);
  *NComponents=--color;
  ERRORMESS("Value OK\n");
}

static void Fixed_Point_Second_Order_Improvement(int *improved)
{ int i;     
  double w;
  ERRORMESS("Trying to improve the policy");
      for (i=0;i<narcs; i++)
	{
	  w=a[i]+ v[tail(ij,i)];
	  if (w>vaux[head(ij,i)] + epsilon)
	    {
	      Show_Info_Improve_Bias(i);
	      *improved=1;
	      vaux[head(ij,i)]=w;
	      newpi[head(ij,i)]=tail(ij,i);
	      newc[head(ij,i)]=a[i];
	    }
	}
}

static void Fixed_Point_Improve(int *improved)
{
  *improved=0;
  Init_Improve();
  Fixed_Point_Second_Order_Improvement(improved);
}


int Fixed_Point_Howard(int *IJ, double *A,int NNODES,int NARCS,double *CHI,double *V,int *POLICY,int *NITERATIONS,int *NCOMPONENTS,int VERBOSE)
{
  int improved=0;
  *NITERATIONS=0;
  Import_Arguments(IJ,A,NNODES,NARCS,CHI,V,POLICY,NITERATIONS,NCOMPONENTS,VERBOSE);
  ERRORTYPE=Security_Check();
  if (ERRORTYPE !=0) return(ERRORTYPE);
  Allocate_Memory();
  Epsilon(a,narcs,&epsilon);
  /*  printf("epsilon=%f\n",epsilon);*/
  Fixed_Point_Initial_Policy3();
  New_Build_Inverse();
  do
    { 
       Fixed_Point_Value();
       Show_Info();
       Fixed_Point_Improve(&improved);
       Update_Policy();
       New_Build_Inverse();
       (*NIterations)++;
     }
  while ((improved != 0) && (*NIterations <MAX_NIterations) && (positivecycle==0));
  /*  printf("howard number of it =%d\n",*NIterations);*/
  Free_Memory();
  ERRORTYPE=End_Message();return(ERRORTYPE);
}

int Fixed_Point_Howard2(int *IJ, double *A,int NNODES,int NARCS,double *CHI,double *V,int *POLICY,int *NITERATIONS,int *NCOMPONENTS,int VERBOSE)
{
  int improved=0;
  *NITERATIONS=0;
  Import_Arguments(IJ,A,NNODES,NARCS,CHI,V,POLICY,NITERATIONS,NCOMPONENTS,VERBOSE);
  ERRORTYPE=Security_Check();
  if (ERRORTYPE !=0) return(ERRORTYPE);
  Allocate_Memory();
  Epsilon(a,narcs,&epsilon);
  Initial_Policy();
  New_Build_Inverse();
  do
    { 
       Fixed_Point_Value();
       Show_Info();
       Fixed_Point_Improve(&improved);
       Update_Policy();
       New_Build_Inverse();
       (*NIterations)++;
     }
  while ((improved != 0) && (*NIterations <MAX_NIterations) && (positivecycle==0));
  Free_Memory();
  /*  printf("howard 2 number of it =%d\n",*NIterations);*/
  ERRORTYPE=End_Message();return(ERRORTYPE);
}






