#include <stdlib.h>
#include <stdio.h>

#include <math.h>

#ifndef RAND_MAX
#define RAND_MAX 2147483647
#endif

#define head(ij,k) ij[k<<1]
#define tail(ij,k) ij[(k<<1)+1]     

void Make_Rand_Sparse_Matrix(int nnodes, int N,int *ij,double *A)
{
  int i,j;
  int k=0;
  double v;
    for (i=0;i<nnodes; i++)
    {
      for (j=0;j<N; j++)
	{
	  ij[k*2]=i;
	  v=rand();
	  ij[k*2+1]=(int)(nnodes*v/(RAND_MAX+1.0));
	  v=rand();
	  /* 	  A[k]=floor(v*2/(RAND_MAX+1.0));*/
	  A[k]=(v*100/(RAND_MAX+1.0));
	  k++;
	}
    }
}

void Fixed_Point_Make_Rand_Sparse_Matrix(int nnodes, int N,int *ij,double *A)
{
  int i,j;
  int k=0;
  double v;
    for (i=0;i<nnodes-1; i++)
    {
      for (j=0;j<N; j++)
	{
	  ij[k*2]=i;
	  v=rand(); ij[k*2+1]=(int)((nnodes-1)*v/(RAND_MAX+1.0)); 
	  v=rand(); A[k]=-(v*100/(RAND_MAX+1.0));
	  k++;
	}
       ij[k*2]=i;
       ij[k*2+1]=nnodes-1;
       v=rand(); 
       A[k]=-1000000*(v/(RAND_MAX+1.0));
       /*       A[k]=-1000000-i*1000; trick to guarantee long enough paths */ 
       k++;
    }
    ij[2*k]=nnodes-1;
    ij[2*k+1]=nnodes-1;
    A[k]=0;
}

/* p x q grid */
void Fixed_Point_Make_Rand_Grid(int p, int q,int *ij,double *A, int *narcs)
{
  int i,j,lnnodes,k=0;
  double v;
  lnnodes=p*q+1;
  for (i=0; i<p; i++)
    {
      for (j=0; j<q-1; j++)      /* arcs (i,j) --> (i,j+1) */
	{
	  head(ij,k)=i+p*j;
	  tail(ij,k)=i+p*(j+1);
	  v=rand(); A[k]=-floor(v*100/(RAND_MAX+1.0));
	  k++;
	}
      for (j=1; j<q; j++)      /* arcs (i,j) --> (i,j-1) */
	{
	  head(ij,k)=i+p*j;
	  tail(ij,k)=i+p*(j-1);
	  v=rand(); A[k]=-floor(v*100/(RAND_MAX+1.0));
	  k++;
	}
    }
  for (j=0; j<q; j++)
    {
      for (i=0; i<p-1; i++)      /* arcs (i,j) --> (i+1,j) */
	{
	  head(ij,k)=i+p*j;
	  tail(ij,k)=i+1+p*j;
	  v=rand(); A[k]=-floor(v*100/(RAND_MAX+1.0));
	  k++;
	}
      for (i=1; i<p; i++)      /* arcs (i,j) --> (i-1,j) */
	{
	  head(ij,k)=i+p*j;
	  tail(ij,k)=i-1+p*j;
	  v=rand(); A[k]=-floor(v*100/(RAND_MAX+1.0));
	  k++;
	}
    }
for (i=0;i<p*q;i++)
  { 
    head(ij,k)=i;
    tail(ij,k)=lnnodes-1;
    v=rand();
    A[k]=-10000000000;
    k++;
  }
for (i=p-1;i<p;i++)
  { 
    head(ij,k)=i+p*(q-1);
    tail(ij,k)=lnnodes-1;
    v=rand();
    A[k]=-floor(v*100/(RAND_MAX+1.0));
    k++;
  }
    head(ij,k)=lnnodes-1;
    tail(ij,k)=lnnodes-1;
    A[k]=0;
    k++;
    *narcs=k;
}


void Semi_Make_Rand_Sparse_Matrix(int nnodes, int N,int *ij,double *A, double *t)
{
  int i,j;
  int k=0;
  double v;
    for (i=0;i<nnodes; i++)
    {
      for (j=0;j<N; j++)
	{
	  ij[k*2]=i;
	  v=rand();
	  ij[k*2+1]=(int)(nnodes*v/(RAND_MAX+1.0));
	  v=rand();
	  /* 	  A[k]=floor(v*2/(RAND_MAX+1.0));*/
	  A[k]=(v*100/(RAND_MAX+1.0));
	  v=rand();
	  /* 	  A[k]=floor(v*2/(RAND_MAX+1.0));*/
	  /* t[k]= 2;*/
	  t[k]=(v+1)*100/(RAND_MAX+1.0);
/*	  printf("time =%g v=%g RAND_MAX=%g\n",t[k],v,RAND_MAX);*/
	  k++;
	}
    }
}

void Make_Rand_Min_Max(int nnodes, int NPOLICIESPERNODE,int NARCSPERNODEANDPOLICY,int *ij,double *A,int *P,int *U)
{
  int i,j,l;
  int k=0;
  double v;
    for (i=0;i<nnodes; i++)
    {
      U[i]=NPOLICIESPERNODE;
      for (l=0;l<NPOLICIESPERNODE; l++)
	{
	for (j=0;j<NARCSPERNODEANDPOLICY; j++)
	  {
	    ij[k*2]=i;
	    v=rand();
	    ij[k*2+1]=(int)(nnodes*v/(RAND_MAX+1.0));
	    v=rand();
	    A[k]=floor((v*2/(RAND_MAX+1.0)));
	    P[k]=l;
	    k++;
	  }
	}
    }
}
void Generate_lp_file(int narcs, int *ij,double *A)
{
  int i;
  printf("PROBLEM DESCRIPTION\n");
  printf("t-z;\n");
  for (i=0;i<narcs; i++)
      {
	printf("%f +x%d-y%d< z-t + x%d-y%d;\n",A[i],ij[i*2+1],ij[i*2+1],ij[i*2],ij[i*2]);
      }
}

